' ****************************************************************************************************
' CHEETAH2.INC - CHEETAH DATABASE SYSTEM DLL DECLARES
'
' DECLARES FOR POWERBASIC PB/CC, PB/DLL, PB/WIN COMPILERS.
' Created: 07-26-2005
' ****************************************************************************************************

' ----------------------------------------------------------------------------------------------------
' DATABASE ROUTINES - Creation/Opening/Closing 
' ----------------------------------------------------------------------------------------------------
     Declare Sub xdbCreate Lib "CHEETAH2.DLL" Alias "XDBCREATE" (dbFile$, FieldArray$())
     Declare Sub xdbCreate_Z Lib "CHEETAH2.DLL" Alias "XDBCREATE_Z" (dbFile As Asciiz, AllFields As Asciiz)
     Declare Sub xdbCreateExtended Lib "CHEETAH2.DLL" Alias "XDBCREATEEXTENDED" (tFileName$, FieldArray$(), ByVal MemoBlockSize&, ByVal Algorithm&, EncryptionKey$) 
     Declare Sub xdbCreateExtended_Z Lib "CHEETAH2.DLL" Alias "XDBCREATEEXTENDED_Z" (tFileName As Asciiz, AllFields As Asciiz, ByVal MemoBlockSize&, ByVal Algorithm&, EncryptionKey As Asciiz) 
     Declare Function xdbOpen& Lib "CHEETAH2.DLL" Alias "XDBOPEN" (dbFile$, Optional EncryptionKey$)
     Declare Function xdbOpen_Z& Lib "CHEETAH2.DLL" Alias "XDBOPEN_Z" (dbFile As Asciiz, Optional EncryptionKey As Asciiz)
     Declare Function xdbOpenEX& Lib "CHEETAH2.DLL" Alias "XDBOPENEX" (dbFile$, ByVal AccessMode&, ByVal ShareMode&, Optional EncryptionKey$)
     Declare Function xdbOpenEX_Z& Lib "CHEETAH2.DLL" Alias "XDBOPENEX_Z" (dbFile As Asciiz, ByVal AccessMode&, ByVal ShareMode&, Optional EncryptionKey As Asciiz)
     Declare Function xdbAlias$ Lib "CHEETAH2.DLL" Alias "XDBALIAS" (ByVal dbHandle&)
     Declare Function xdbAlias_Z Lib "CHEETAH2.DLL" Alias "XDBALIAS_Z" (ByVal dbHandle&) As Long
     Declare Sub xdbSetAlias Lib "CHEETAH2.DLL" Alias "XDBSETALIAS" (ByVal dbHandle&, AliasName$)
     Declare Sub xdbSetAlias_Z Lib "CHEETAH2.DLL" Alias "XDBSETALIAS_Z" (ByVal dbHandle&, AliasName As Asciiz)
     Declare Sub xdbCreateFields Lib "CHEETAH2.DLL" Alias "XDBCREATEFIELDS" (mFileName$)
     Declare Sub xdbCreateFields_Z Lib "CHEETAH2.DLL" Alias "XDBCREATEFIELDS_Z" (mFileName As Asciiz)
     Declare Sub xdbCreateFieldsExtended Lib "CHEETAH2.DLL" Alias "XDBCREATEFIELDSEXTENDED" (mFileName$, ByVal MemoBlockSize&, ByVal Algorithm&, EncryptionKey$) 
     Declare Sub xdbCreateFieldsExtended_Z Lib "CHEETAH2.DLL" Alias "XDBCREATEFIELDSEXTENDED_Z" (mFileName As Asciiz, ByVal MemoBlockSize&, ByVal Algorithm&, EncryptionKey As Asciiz) 
     Declare Sub xdbAddField Lib "CHEETAH2.DLL" Alias "XDBADDFIELD" (FieldInfoString$)
     Declare Sub xdbAddField_Z Lib "CHEETAH2.DLL" Alias "XDBADDFIELD_Z" (FieldInfoString As Asciiz)
     Declare Sub xdbClose Lib "CHEETAH2.DLL" Alias "XDBCLOSE" (ByVal dbHandle&)
     Declare Sub xdbClose_Z Lib "CHEETAH2.DLL" Alias "XDBCLOSE_Z" (ByVal dbHandle&)
     Declare Sub xdbCloseAllIndexes Lib "CHEETAH2.DLL" Alias "XDBCLOSEALLINDEXES" (ByVal dbHandle&)
     Declare Sub xdbCloseAllIndexes_Z Lib "CHEETAH2.DLL" Alias "XDBCLOSEALLINDEXES_Z" (ByVal dbHandle&)

' ----------------------------------------------------------------------------------------------------
' DATABASE ROUTINES - MultiUser & Locking  
' ----------------------------------------------------------------------------------------------------
     Declare Sub xdbMultiUser Lib "CHEETAH2.DLL" Alias "XDBMULTIUSER" (ByVal TrueFalse&, ByVal NumRetries&, ByVal WaitTime&) 
     Declare Sub xdbMultiUser_Z Lib "CHEETAH2.DLL" Alias "XDBMULTIUSER_Z" (ByVal TrueFalse&, ByVal NumRetries&, ByVal WaitTime&) 
     Declare Function xdbMultiThreaded Lib "CHEETAH2.DLL" Alias "XDBMULTITHREADED" (ByVal OnOff As Long) As Long  
     Declare Sub xdbFailedLockInfo Lib "CHEETAH2.DLL" Alias "XDBFAILEDLOCKINFO" (ByVal DBFhandle&, Reason$, Username$, Workstation$, LockDate$, LockTime$) 
     Declare Sub xdbFailedLockInfo_Z Lib "CHEETAH2.DLL" Alias "XDBFAILEDLOCKINFO_Z" (ByVal DBFhandle&, zReason As Long, zUsername As Long, zWorkstation As Long, zLockDate As Long, zLockTime As Long) 
     Declare Sub xdbActivate Lib "CHEETAH2.DLL" Alias "XDBACTIVATE" (ByVal ActivateNumber As Long) 
     Declare Sub xdbActivate_Z Lib "CHEETAH2.DLL" Alias "XDBACTIVATE_Z" (ByVal ActivateNumber As Long) 
     Declare Function xdbSetExclusiveLock& Lib "CHEETAH2.DLL" Alias "XDBSETEXCLUSIVELOCK" (ByVal DBFhandle&) 
     Declare Function xdbSetExclusiveLock_Z& Lib "CHEETAH2.DLL" Alias "XDBSETEXCLUSIVELOCK_Z" (ByVal DBFhandle&) 
     Declare Sub xdbRemoveExclusiveLock Lib "CHEETAH2.DLL" Alias "XDBREMOVEEXCLUSIVELOCK" (ByVal DBFhandle&, ByVal LOCK_NUM&) 
     Declare Sub xdbRemoveExclusiveLock_Z Lib "CHEETAH2.DLL" Alias "XDBREMOVEEXCLUSIVELOCK_Z" (ByVal DBFhandle&, ByVal LOCK_NUM&) 
     Declare Function xdbSetEditLock& Lib "CHEETAH2.DLL" Alias "XDBSETEDITLOCK" (ByVal DBFhandle&, ByVal RecordNumber&) 
     Declare Function xdbSetEditLock_Z& Lib "CHEETAH2.DLL" Alias "XDBSETEDITLOCK_Z" (ByVal DBFhandle&, ByVal RecordNumber&) 
     Declare Sub xdbRemoveEditLock Lib "CHEETAH2.DLL" Alias "XDBREMOVEEDITLOCK" (ByVal DBFhandle&, ByVal LOCK_NUM&) 
     Declare Sub xdbRemoveEditLock_Z Lib "CHEETAH2.DLL" Alias "XDBREMOVEEDITLOCK_Z" (ByVal DBFhandle&, ByVal LOCK_NUM&) 
     Declare Function xdbIsEditLock& Lib "CHEETAH2.DLL" Alias "XDBISEDITLOCK" (ByVal DBFhandle&, ByVal RecordNumber&)  
     Declare Function xdbIsEditLock_Z& Lib "CHEETAH2.DLL" Alias "XDBISEDITLOCK_Z" (ByVal DBFhandle&, ByVal RecordNumber&)  

' ----------------------------------------------------------------------------------------------------
' DATABASE ROUTINES - Adding/Deleting Records 
' ----------------------------------------------------------------------------------------------------
     Declare Sub xdbAddRecord Lib "CHEETAH2.DLL" Alias "XDBADDRECORD" (ByVal dbHandle&)
     Declare Sub xdbAddRecord_Z Lib "CHEETAH2.DLL" Alias "XDBADDRECORD_Z" (ByVal dbHandle&)
     Declare Sub xdbAppendRecord Lib "CHEETAH2.DLL" Alias "XDBAPPENDRECORD" (ByVal DBFhandle&)
     Declare Sub xdbAppendRecord_Z Lib "CHEETAH2.DLL" Alias "XDBAPPENDRECORD_Z" (ByVal DBFhandle&)
     Declare Sub xdbClearBuffer Lib "CHEETAH2.DLL" Alias "XDBCLEARBUFFER" (ByVal dbHandle&)
     Declare Sub xdbClearBuffer_Z Lib "CHEETAH2.DLL" Alias "XDBCLEARBUFFER_Z" (ByVal dbHandle&)
     Declare Sub xdbPutRecord Lib "CHEETAH2.DLL" Alias "XDBPUTRECORD" (ByVal dbHandle&, RN&)
     Declare Sub xdbPutRecord_Z Lib "CHEETAH2.DLL" Alias "XDBPUTRECORD_Z" (ByVal dbHandle&, RN&)
     Declare Sub xdbGetRecord Lib "CHEETAH2.DLL" Alias "XDBGETRECORD" (ByVal dbHandle&, ByVal RN&)
     Declare Sub xdbGetRecord_Z Lib "CHEETAH2.DLL" Alias "XDBGETRECORD_Z" (ByVal dbHandle&, ByVal RN&)
     Declare Sub xdbDeleteRecord Lib "CHEETAH2.DLL" Alias "XDBDELETERECORD" (ByVal DBFhandle&, ByVal RecordNumber&)
     Declare Sub xdbDeleteRecord_Z Lib "CHEETAH2.DLL" Alias "XDBDELETERECORD_Z" (ByVal DBFhandle&, ByVal RecordNumber&)
     Declare Sub xdbRecallRecord Lib "CHEETAH2.DLL" Alias "XDBRECALLRECORD" (ByVal DBFhandle&, ByVal RecordNumber&)
     Declare Sub xdbRecallRecord_Z Lib "CHEETAH2.DLL" Alias "XDBRECALLRECORD_Z" (ByVal DBFhandle&, ByVal RecordNumber&)
     Declare Function xdbDeleted& Lib "CHEETAH2.DLL" Alias "XDBDELETED" (ByVal DBFhandle&, ByVal RecordNumber&)
     Declare Function xdbDeleted_Z& Lib "CHEETAH2.DLL" Alias "XDBDELETED_Z" (ByVal DBFhandle&, ByVal RecordNumber&)
     Declare Sub xdbFlushDatabase Lib "CHEETAH2.DLL" Alias "XDBFLUSHDATABASE" (ByVal dbHandle&)
     Declare Sub xdbFlushDatabase_Z Lib "CHEETAH2.DLL" Alias "XDBFLUSHDATABASE_Z" (ByVal dbHandle&)
     Declare Sub xdbPack Lib "CHEETAH2.DLL" Alias "XDBPACK" ( ByVal DBFhandle&)
     Declare Sub xdbPack_Z Lib "CHEETAH2.DLL" Alias "XDBPACK_Z" ( ByVal DBFhandle&)
     Declare Sub xdbZap Lib "CHEETAH2.DLL" Alias "XDBZAP" ( ByVal DBFhandle&)
     Declare Sub xdbZap_Z Lib "CHEETAH2.DLL" Alias "XDBZAP_Z" ( ByVal DBFhandle&)
     Declare Function xdbRecordBuffer$ Lib "CHEETAH2.DLL" Alias "XDBRECORDBUFFER" (ByVal DBFhandle&) 
     Declare Function xdbRecordBuffer_Z Lib "CHEETAH2.DLL" Alias "XDBRECORDBUFFER_Z" (ByVal DBFhandle&) As Long 
     Declare Sub xdbSpeedAppend Lib "CHEETAH2.DLL" Alias "XDBSPEEDAPPEND" (ByVal DBFhandle&, ByVal TrueFalse&)
     Declare Sub xdbSpeedAppend_Z Lib "CHEETAH2.DLL" Alias "XDBSPEEDAPPEND_Z" (ByVal DBFhandle&, ByVal TrueFalse&)

' ----------------------------------------------------------------------------------------------------
' DATABASE ROUTINES - Database Information
' ----------------------------------------------------------------------------------------------------
     Declare Function xdbRecordCount& Lib "CHEETAH2.DLL" Alias "XDBRECORDCOUNT" (ByVal dbHandle&)
     Declare Function xdbRecordCount_Z& Lib "CHEETAH2.DLL" Alias "XDBRECORDCOUNT_Z" (ByVal dbHandle&)
     Declare Function xdbFieldCount& Lib "CHEETAH2.DLL" Alias "XDBFIELDCOUNT" (ByVal dbHandle&)
     Declare Function xdbFieldCount_Z& Lib "CHEETAH2.DLL" Alias "XDBFIELDCOUNT_Z" (ByVal dbHandle&)
     Declare Function xdbFieldNumber& Lib "CHEETAH2.DLL" Alias "XDBFIELDNUMBER" (ByVal dbHandle&, FieldName$)
     Declare Function xdbFieldNumber_Z& Lib "CHEETAH2.DLL" Alias "XDBFIELDNUMBER_Z" (ByVal dbHandle&, FieldName As Asciiz)
     Declare Function xdbRecordNumber& Lib "CHEETAH2.DLL" Alias "XDBRECORDNUMBER" (ByVal DBFhandle&)
     Declare Function xdbRecordNumber_Z& Lib "CHEETAH2.DLL" Alias "XDBRECORDNUMBER_Z" (ByVal DBFhandle&)
     Declare Sub xdbLastUpdated Lib "CHEETAH2.DLL" Alias "XDBLASTUPDATED" (ByVal dbHandle&, YearNr&, MonthNr&, DayNr&)
     Declare Sub xdbLastUpdated_Z Lib "CHEETAH2.DLL" Alias "XDBLASTUPDATED_Z" (ByVal dbHandle&, YearNr&, MonthNr&, DayNr&)
     Declare Sub xdbFieldInfo Lib "CHEETAH2.DLL" Alias "XDBFIELDINFO" (ByVal DBFhandle&, ByVal FieldNumber&, FieldName$, FieldType$, FieldLength&, FieldDecimals&)
     Declare Sub xdbFieldInfo_Z Lib "CHEETAH2.DLL" Alias "XDBFIELDINFO_Z" (ByVal DBFhandle&, ByVal FieldNumber&, zFieldName As Long, zFieldType As Long, FieldLength&, FieldDecimals&)
     Declare Function xdbFieldName$ Lib "CHEETAH2.DLL" Alias "XDBFIELDNAME" (ByVal DBFhandle&, ByVal FieldNumber&)
     Declare Function xdbFieldName_Z Lib "CHEETAH2.DLL" Alias "XDBFIELDNAME_Z" (ByVal DBFhandle&, ByVal FieldNumber&) As Long
     Declare Function xdbFieldType$ Lib "CHEETAH2.DLL" Alias "XDBFIELDTYPE" (ByVal DBFhandle&, ByVal FieldNumber&)
     Declare Function xdbFieldType_Z Lib "CHEETAH2.DLL" Alias "XDBFIELDTYPE_Z" (ByVal DBFhandle&, ByVal FieldNumber&) As Long
     Declare Function xdbFieldLength& Lib "CHEETAH2.DLL" Alias "XDBFIELDLENGTH" (ByVal DBFhandle&, ByVal FieldNumber&)
     Declare Function xdbFieldLength_Z& Lib "CHEETAH2.DLL" Alias "XDBFIELDLENGTH_Z" (ByVal DBFhandle&, ByVal FieldNumber&)
     Declare Function xdbFieldDecimals& Lib "CHEETAH2.DLL" Alias "XDBFIELDDECIMALS" (ByVal DBFhandle&, ByVal FieldNumber&)
     Declare Function xdbFieldDecimals_Z& Lib "CHEETAH2.DLL" Alias "XDBFIELDDECIMALS_Z" (ByVal DBFhandle&, ByVal FieldNumber&)
     Declare Sub xdbDatabaseHandles Lib "CHEETAH2.DLL" Alias "XDBDATABASEHANDLES" (DBFfilename$, CheetahHandle&, WindowsHandle&)
     Declare Sub xdbDatabaseHandles_Z Lib "CHEETAH2.DLL" Alias "XDBDATABASEHANDLES_Z" (DBFfilename As Asciiz, CheetahHandle&, WindowsHandle&)
     Declare Sub xdbIndexHandles Lib "CHEETAH2.DLL" Alias "XDBINDEXHANDLES" (IDXfilename$, CheetahHandle&, WindowsHandle&)
     Declare Sub xdbIndexHandles_Z Lib "CHEETAH2.DLL" Alias "XDBINDEXHANDLES_Z" (IDXfilename As Asciiz, CheetahHandle&, WindowsHandle&)

' ----------------------------------------------------------------------------------------------------
' DATABASE ROUTINES - Navigating the Database 
' ----------------------------------------------------------------------------------------------------
     Declare Function xdbEOF& Lib "CHEETAH2.DLL" Alias "XDBEOF" (ByVal DBFhandle&)
     Declare Function xdbEOF_Z& Lib "CHEETAH2.DLL" Alias "XDBEOF_Z" (ByVal DBFhandle&)
     Declare Function xdbBOF& Lib "CHEETAH2.DLL" Alias "XDBBOF" (ByVal DBFhandle&)
     Declare Function xdbBOF_Z& Lib "CHEETAH2.DLL" Alias "XDBBOF_Z" (ByVal DBFhandle&)
     Declare Sub xdbMoveFirst Lib "CHEETAH2.DLL" Alias "XDBMOVEFIRST" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbMoveFirst_Z Lib "CHEETAH2.DLL" Alias "XDBMOVEFIRST_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbMoveNext Lib "CHEETAH2.DLL" Alias "XDBMOVENEXT" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbMoveNext_Z Lib "CHEETAH2.DLL" Alias "XDBMOVENEXT_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbMoveLast Lib "CHEETAH2.DLL" Alias "XDBMOVELAST" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbMoveLast_Z Lib "CHEETAH2.DLL" Alias "XDBMOVELAST_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbMovePrev Lib "CHEETAH2.DLL" Alias "XDBMOVEPREV" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbMovePrev_Z Lib "CHEETAH2.DLL" Alias "XDBMOVEPREV_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbSkipDeleted Lib "CHEETAH2.DLL" Alias "XDBSKIPDELETED" (ByVal DBFhandle&, ByVal TrueFalse&)
     Declare Sub xdbSkipDeleted_Z Lib "CHEETAH2.DLL" Alias "XDBSKIPDELETED_Z" (ByVal DBFhandle&, ByVal TrueFalse&)
     Declare Function xdbKeyPosition& Lib "CHEETAH2.DLL" Alias "XDBKEYPOSITION" (ByVal DBFhandle&, ByVal IDXhandle&, ByVal KeyPosition&) 
     Declare Function xdbKeyPosition_Z& Lib "CHEETAH2.DLL" Alias "XDBKEYPOSITION_Z" (byval DBFhandle&, ByVal IDXhandle&, ByVal KeyPosition&) 

' ----------------------------------------------------------------------------------------------------
' DATABASE ROUTINES - Assigning Field Values 
' ----------------------------------------------------------------------------------------------------
     Declare Sub xdbAssignField Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELD" (ByVal dbHandle&, FieldName$, ByVal FieldNumber&, FieldString$)
     Declare Sub xdbAssignField_Z Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELD_Z" (ByVal dbHandle&, FieldName As Asciiz, ByVal FieldNumber&, FieldString As Asciiz)
     Declare Sub xdbAssignMemo_Z Lib "CHEETAH2.DLL" Alias "XDBASSIGNMEMO_Z" (ByVal dbHandle&, zFieldName As Asciiz, ByVal FieldNumber&, ByVal MemAddress As Long, StringLength As Long)
     Declare Sub xdbAssignFieldINT Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDINT" (ByVal dbHandle&, FieldName$, ByVal FieldNumber&, FieldInteger%)
     Declare Sub xdbAssignFieldINT_Z Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDINT_Z" (ByVal dbHandle&, FieldName As Asciiz, ByVal FieldNumber&, FieldInteger%)
     Declare Sub xdbAssignFieldLNG Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDLNG" (ByVal dbHandle&, FieldName$, ByVal FieldNumber&, FieldLong&)
     Declare Sub xdbAssignFieldLNG_Z Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDLNG_Z" (ByVal dbHandle&, FieldName As Asciiz, ByVal FieldNumber&, FieldLong&)
     Declare Sub xdbAssignFieldSNG Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDSNG" (ByVal dbHandle&, FieldName$, ByVal FieldNumber&, FieldSingle!)
     Declare Sub xdbAssignFieldSNG_Z Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDSNG_Z" (ByVal dbHandle&, FieldName As Asciiz, ByVal FieldNumber&, FieldSingle!)
     Declare Sub xdbAssignFieldDBL Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDDBL" (ByVal dbHandle&, FieldName$, ByVal FieldNumber&, FieldDouble#)
     Declare Sub xdbAssignFieldDBL_Z Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDDBL_Z" (ByVal dbHandle&, FieldName As Asciiz, ByVal FieldNumber&, FieldDouble#)
     Declare Sub xdbAssignFieldCUR Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDCUR" (ByVal dbHandle&, FieldName$, ByVal FieldNumber&, FieldCurrency@)
     Declare Sub xdbAssignFieldCUR_Z Lib "CHEETAH2.DLL" Alias "XDBASSIGNFIELDCUR_Z" (ByVal dbHandle&, FieldName As Asciiz, ByVal FieldNumber&, FieldCurrency@)

' ----------------------------------------------------------------------------------------------------
' DATABASE ROUTINES - Retrieving Field Values 
' ----------------------------------------------------------------------------------------------------
     Declare Function xdbMemoValueLen_Z Lib "CHEETAH2.DLL" Alias "XDBMEMOVALUELEN_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&) As Long
     Declare Function xdbMemoValueAddr_Z Lib "CHEETAH2.DLL" Alias "XDBMEMOVALUEADDR_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&) As Long
     Declare Function xdbFieldValue$ Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUE" (ByVal DBFhandle&, FieldName$, ByVal FieldCode&)
     Declare Function xdbFieldValue_Z Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUE_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&) As Long
     Declare Function xdbFieldValueINT% Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUEINT" (ByVal DBFhandle&, FieldName$, ByVal FieldCode&)
     Declare Function xdbFieldValueINT_Z% Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUEINT_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&)
     Declare Function xdbFieldValueLNG& Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUELNG" (ByVal DBFhandle&, FieldName$, ByVal FieldCode&)
     Declare Function xdbFieldValueLNG_Z& Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUELNG_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&)
     Declare Function xdbFieldValueSNG! Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUESNG" (ByVal DBFhandle&, FieldName$, ByVal FieldCode&)
     Declare Function xdbFieldValueSNG_Z! Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUESNG_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&)
     Declare Function xdbFieldValueDBL# Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUEDBL" (ByVal DBFhandle&, FieldName$, ByVal FieldCode&)
     Declare Function xdbFieldValueDBL_Z# Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUEDBL_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&)
     Declare Function xdbFieldValueCUR@ Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUECUR" (ByVal DBFhandle&, FieldName$, ByVal FieldCode&)
     Declare Function xdbFieldValueCUR_Z@ Lib "CHEETAH2.DLL" Alias "XDBFIELDVALUECUR_Z" (ByVal DBFhandle&, FieldName As Asciiz, ByVal FieldCode&)
     Declare Sub xdbFieldPadding Lib "CHEETAH2.DLL" Alias "XDBFIELDPADDING" (ByVal DBFhandle&, ByVal TrueFalse&)
     Declare Sub xdbFieldPadding_Z Lib "CHEETAH2.DLL" Alias "XDBFIELDPADDING_Z" (ByVal DBFhandle&, ByVal TrueFalse&)

' ----------------------------------------------------------------------------------------------------
' INDEX ROUTINES - Creation/Opening/Closing 
' ----------------------------------------------------------------------------------------------------
     Declare Sub xdbCreateIndex Lib "CHEETAH2.DLL" Alias "XDBCREATEINDEX" (iFilename$, ByVal dbHandle&, IndexExpression$, ByVal Duplicates&)
     Declare Sub xdbCreateIndex_Z Lib "CHEETAH2.DLL" Alias "XDBCREATEINDEX_Z" (iFilename As Asciiz, ByVal dbHandle&, IndexExpression As Asciiz, ByVal Duplicates&)
     Declare Function xdbOpenIndex& Lib "CHEETAH2.DLL" Alias "XDBOPENINDEX" (iFilename$, ByVal dbHandle&)
     Declare Function xdbOpenIndex_Z& Lib "CHEETAH2.DLL" Alias "XDBOPENINDEX_Z" (iFilename As Asciiz, ByVal dbHandle&)
     Declare Sub xdbCloseIndex Lib "CHEETAH2.DLL" Alias "XDBCLOSEINDEX" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbCloseIndex_Z Lib "CHEETAH2.DLL" Alias "XDBCLOSEINDEX_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Sub xdbReindex Lib "CHEETAH2.DLL" Alias "XDBREINDEX" (ByVal DBFhandle&, ByVal idxHandle&, Optional ByVal ContinueOrError&)
     Declare Sub xdbReindex_Z Lib "CHEETAH2.DLL" Alias "XDBREINDEX_Z" (ByVal DBFhandle&, ByVal idxHandle&, Optional ByVal ContinueOrError&)
     Declare Sub xdbReindexAll Lib "CHEETAH2.DLL" Alias "XDBREINDEXALL" (ByVal DBFhandle&, Optional ByVal ContinueOrError&) 
     Declare Sub xdbReindexAll_Z Lib "CHEETAH2.DLL" Alias "XDBREINDEXALL_Z" (ByVal DBFhandle&, Optional ByVal ContinueOrError&) 
     Declare Function xdbSeek& Lib "CHEETAH2.DLL" Alias "XDBSEEK" (ByVal DBFhandle&, ByVal idxHandle&, LookForKey$)
     Declare Function xdbSeek_Z& Lib "CHEETAH2.DLL" Alias "XDBSEEK_Z" (ByVal DBFhandle&, ByVal idxHandle&, LookForKey As Asciiz)
     Declare Function xdbSeekNext& Lib "CHEETAH2.DLL" Alias "XDBSEEKNEXT" (ByVal dbHandle&, ByVal idxHandle&, LookForKey$)
     Declare Function xdbSeekNext_Z& Lib "CHEETAH2.DLL" Alias "XDBSEEKNEXT_Z" (ByVal dbHandle&, ByVal idxHandle&, LookForKey As Asciiz)
     Declare Function xdbSeekPartial& Lib "CHEETAH2.DLL" Alias "XDBSEEKPARTIAL" (ByVal dbHandle&, ByVal idxHandle&, LookForKey$)
     Declare Function xdbSeekPartial_Z& Lib "CHEETAH2.DLL" Alias "XDBSEEKPARTIAL_Z" (ByVal dbHandle&, ByVal idxHandle&, LookForKey As Asciiz)
     Declare Function xdbSeekPartialNext& Lib "CHEETAH2.DLL" Alias "XDBSEEKPARTIALNEXT" (ByVal dbHandle&, ByVal idxHandle&, LookForKey$)
     Declare Function xdbSeekPartialNext_Z& Lib "CHEETAH2.DLL" Alias "XDBSEEKPARTIALNEXT_Z" (ByVal dbHandle&, ByVal idxHandle&, LookForKey As Asciiz)
     Declare Sub xdbSetCallback Lib "CHEETAH2.DLL" Alias "XDBSETCALLBACK" (ByVal hWnd&)
     Declare Sub xdbSetCallback_Z Lib "CHEETAH2.DLL" Alias "XDBSETCALLBACK_Z" (ByVal hWnd&)

' ----------------------------------------------------------------------------------------------------
' INDEX ROUTINES - Index information 
' ----------------------------------------------------------------------------------------------------
     Declare Function xdbKeyLength& Lib "CHEETAH2.DLL" Alias "XDBKEYLENGTH" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Function xdbKeyLength_Z& Lib "CHEETAH2.DLL" Alias "XDBKEYLENGTH_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Function xdbKeyCount& Lib "CHEETAH2.DLL" Alias "XDBKEYCOUNT" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Function xdbKeyCount_Z& Lib "CHEETAH2.DLL" Alias "XDBKEYCOUNT_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Function xdbKeyUnique& Lib "CHEETAH2.DLL" Alias "XDBKEYUNIQUE" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Function xdbKeyUnique_Z& Lib "CHEETAH2.DLL" Alias "XDBKEYUNIQUE_Z" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Function xdbKeyExpression$ Lib "CHEETAH2.DLL" Alias "XDBKEYEXPRESSION" (ByVal DBFhandle&, ByVal idxHandle&)
     Declare Function xdbKeyExpression_Z Lib "CHEETAH2.DLL" Alias "XDBKEYEXPRESSION_Z" (ByVal DBFhandle&, ByVal idxHandle&) As Long
     Declare Function xdbMKL$ Lib "CHEETAH2.DLL" Alias "XDBMKL" (ByVal LongValue&)
     Declare Function xdbMKL_Z Lib "CHEETAH2.DLL" Alias "XDBMKL_Z" (ByVal LongValue&) As Long
     Declare Function xdbMKI$ Lib "CHEETAH2.DLL" Alias "XDBMKI" (ByVal IntegerValue%)
     Declare Function xdbMKI_Z Lib "CHEETAH2.DLL" Alias "XDBMKI_Z" (ByVal IntegerValue%) As Long

' ----------------------------------------------------------------------------------------------------
' QUERY ROUTINES 
' ----------------------------------------------------------------------------------------------------
     Declare Function xdbCreateQuery& Lib "CHEETAH2.DLL" Alias "XDBCREATEQUERY" (ByVal DBFhandle&)
     Declare Function xdbCreateQuery_Z& Lib "CHEETAH2.DLL" Alias "XDBCREATEQUERY_Z" (ByVal DBFhandle&)
     Declare Sub xdbQueryCondition Lib "CHEETAH2.DLL" Alias "XDBQUERYCONDITION" (ByVal QueryHandle&, ByVal JoinPhrase&, FieldName$, ByVal Equality&, vParameter1$, vParameter2$)
     Declare Sub xdbQueryCondition_Z Lib "CHEETAH2.DLL" Alias "XDBQUERYCONDITION_Z" (ByVal QueryHandle&, ByVal JoinPhrase&, FieldName As Asciiz, ByVal Equality&, vParameter1 As Asciiz, vParameter2 As Asciiz)
     Declare Sub xdbQuerySort Lib "CHEETAH2.DLL" Alias "XDBQUERYSORT" (ByVal QueryHandle&, FieldName$, ByVal SortDirection&) 
     Declare Sub xdbQuerySort_Z Lib "CHEETAH2.DLL" Alias "XDBQUERYSORT_Z" (ByVal QueryHandle&, FieldName As Asciiz, ByVal SortDirection&) 
     Declare Sub xdbQueryExecute Lib "CHEETAH2.DLL" Alias "XDBQUERYEXECUTE" (ByVal QueryHandle&)
     Declare Sub xdbQueryExecute_Z Lib "CHEETAH2.DLL" Alias "XDBQUERYEXECUTE_Z" (ByVal QueryHandle&)
     Declare Function xdbQuerySUM# Lib "CHEETAH2.DLL" Alias "XDBQUERYSUM" (ByVal QueryHandle&, FieldName$)
     Declare Function xdbQuerySUM_Z# Lib "CHEETAH2.DLL" Alias "XDBQUERYSUM_Z" (ByVal QueryHandle&, FieldName As Asciiz)
     Declare Function xdbQueryMIN# Lib "CHEETAH2.DLL" Alias "XDBQUERYMIN" (ByVal QueryHandle&, FieldName$)
     Declare Function xdbQueryMIN_Z# Lib "CHEETAH2.DLL" Alias "XDBQUERYMIN_Z" (ByVal QueryHandle&, FieldName As Asciiz)
     Declare Function xdbQueryMAX# Lib "CHEETAH2.DLL" Alias "XDBQUERYMAX" (ByVal QueryHandle&, FieldName$)
     Declare Function xdbQueryMAX_Z# Lib "CHEETAH2.DLL" Alias "XDBQUERYMAX_Z" (ByVal QueryHandle&, FieldName As Asciiz)
     Declare Function xdbQueryAVG# Lib "CHEETAH2.DLL" Alias "XDBQUERYAVG" (ByVal QueryHandle&, FieldName$)
     Declare Function xdbQueryAVG_Z# Lib "CHEETAH2.DLL" Alias "XDBQUERYAVG_Z" (ByVal QueryHandle&, FieldName As Asciiz)
     Declare Sub xdbQueryDistinct Lib "CHEETAH2.DLL" Alias "XDBQUERYDISTINCT" (ByVal QueryHandle&, DistinctFieldName$) 
     Declare Sub xdbQueryDistinct_Z Lib "CHEETAH2.DLL" Alias "XDBQUERYDISTINCT_Z" (ByVal QueryHandle&, DistinctFieldName As Asciiz) 
     Declare Sub xdbHtmlStripTag Lib "CHEETAH2.DLL" Alias "XDBHTMLSTRIPTAG" (ByVal QueryHandle&, ByVal TrueFalse&) 
     Declare Sub xdbHtmlStripTag_Z Lib "CHEETAH2.DLL" Alias "XDBHTMLSTRIPTAG_Z" (ByVal QueryHandle&, ByVal TrueFalse&) 
     Declare Sub xdbDestroyQuery Lib "CHEETAH2.DLL" Alias "XDBDESTROYQUERY" (ByVal QueryHandle&)
     Declare Sub xdbDestroyQuery_Z Lib "CHEETAH2.DLL" Alias "XDBDESTROYQUERY_Z" (ByVal QueryHandle&)
     Declare Function xdbQueryIndex& Lib "CHEETAH2.DLL" Alias "XDBQUERYINDEX" (ByVal QueryHandle&)
     Declare Function xdbQueryIndex_Z& Lib "CHEETAH2.DLL" Alias "XDBQUERYINDEX_Z" (ByVal QueryHandle&)

' ----------------------------------------------------------------------------------------------------
' DATE ROUTINES  
' ----------------------------------------------------------------------------------------------------
     Declare Function xdbDaysApart& Lib "CHEETAH2.DLL" Alias "XDBDAYSAPART" (DateFrom$, DateTo$) 
     Declare Function xdbDaysApart_Z& Lib "CHEETAH2.DLL" Alias "XDBDAYSAPART_Z" (DateFrom As Asciiz, DateTo As Asciiz) 
     Declare Function xdbDaysInMonth& Lib "CHEETAH2.DLL" Alias "XDBDAYSINMONTH" (ByVal Year&, ByVal Month&) 
     Declare Function xdbDaysInMonth_Z& Lib "CHEETAH2.DLL" Alias "XDBDAYSINMONTH_Z" (ByVal Year&, ByVal Month&) 
     Declare Function xdbAddDate$ Lib "CHEETAH2.DLL" Alias "XDBADDDATE" (StartDate$, ByVal Days&) 
     Declare Function xdbAddDate_Z Lib "CHEETAH2.DLL" Alias "XDBADDDATE_Z" (StartDate As Asciiz, ByVal Days&) As Long 
     Declare Function xdbNameOfDay$ Lib "CHEETAH2.DLL" Alias "XDBNAMEOFDAY" (DateCheck$) 
     Declare Function xdbNameOfDay_Z Lib "CHEETAH2.DLL" Alias "XDBNAMEOFDAY_Z" (DateCheck As Asciiz) As Long 
     Declare Function xdbTodaysDate$ Lib "CHEETAH2.DLL" Alias "XDBTODAYSDATE" () 
     Declare Function xdbTodaysDate_Z Lib "CHEETAH2.DLL" Alias "XDBTODAYSDATE_Z" () As Long 
     Declare Function xdbValidDate& Lib "CHEETAH2.DLL" Alias "XDBVALIDDATE" (DateCheck$) 
     Declare Function xdbValidDate_Z& Lib "CHEETAH2.DLL" Alias "XDBVALIDDATE_Z" (DateCheck As Asciiz) 
     Declare Function xdbDateToJulian& Lib "CHEETAH2.DLL" Alias "XDBDATETOJULIAN" (DateString$) 
     Declare Function xdbDateToJulian_Z& Lib "CHEETAH2.DLL" Alias "XDBDATETOJULIAN_Z" (DateString As Asciiz) 
     Declare Function xdbJulianToDate$ Lib "CHEETAH2.DLL" Alias "XDBJULIANTODATE" (ByVal JulianNumber&) 
     Declare Function xdbJulianToDate_Z Lib "CHEETAH2.DLL" Alias "XDBJULIANTODATE_Z" (ByVal JulianNumber&) As Long 
     Declare Function CTOD Lib "CHEETAH2.DLL" Alias "CTOD" (PBDate As String) As String 
     Declare Function CTOD_Z Lib "CHEETAH2.DLL" Alias "CTOD_Z" (PBDate As Asciiz) As Long 
     Declare Function DTOS Lib "CHEETAH2.DLL" Alias "DTOS" (xDate As String) As String 
     Declare Function DTOS_Z Lib "CHEETAH2.DLL" Alias "DTOS_Z" (xDate As Asciiz) As Long 

' ----------------------------------------------------------------------------------------------------
' MISCELLANEOUS ROUTINES 
' ----------------------------------------------------------------------------------------------------
     Declare Sub xdbResetError Lib "CHEETAH2.DLL" Alias "XDBRESETERROR" ()
     Declare Sub xdbResetError_Z Lib "CHEETAH2.DLL" Alias "XDBRESETERROR_Z" ()
     Declare Function xdbError& Lib "CHEETAH2.DLL" Alias "XDBERROR" ()
     Declare Function xdbError_Z& Lib "CHEETAH2.DLL" Alias "XDBERROR_Z" ()
     Declare Function xdbVersion$ Lib "CHEETAH2.DLL" Alias "XDBVERSION" () 
     Declare Function xdbVersion_Z Lib "CHEETAH2.DLL" Alias "XDBVERSION_Z" () As Long 
     Declare Function xdbRegisteredTo$ Lib "CHEETAH2.DLL" Alias "XDBREGISTEREDTO" () 
     Declare Function xdbRegisteredTo_Z Lib "CHEETAH2.DLL" Alias "XDBREGISTEREDTO_Z" () As Long 
     Declare Sub xdbDebugMode Lib "CHEETAH2.DLL" Alias "XDBDEBUGMODE" (ByVal UserMode&)
     Declare Sub xdbDebugMode_Z Lib "CHEETAH2.DLL" Alias "XDBDEBUGMODE_Z" (ByVal UserMode&)
     Declare Sub xdbDebugReadStart Lib "CHEETAH2.DLL" Alias "XDBDEBUGREADSTART" ()
     Declare Sub xdbDebugReadEnd Lib "CHEETAH2.DLL" Alias "XDBDEBUGREADEND" ()
     Declare Function xdbAppPath$ Lib "CHEETAH2.DLL" Alias "XDBAPPPATH" ()
     Declare Function xdbAppPath_Z Lib "CHEETAH2.DLL" Alias "XDBAPPPATH_Z" () As Long
     Declare Sub xdbFreeDLL Lib "CHEETAH2.DLL" Alias "XDBFREEDLL" () 
     Declare Sub xdbFreeDLL_Z Lib "CHEETAH2.DLL" Alias "XDBFREEDLL_Z" () 
     Declare Function xdbIsEncrypted& Lib "CHEETAH2.DLL" Alias "XDBISENCRYPTED" (ByVal DBFhandle&) 
     Declare Function xdbIsEncrypted_Z& Lib "CHEETAH2.DLL" Alias "XDBISENCRYPTED_Z" (ByVal DBFhandle&) 
     Declare Function xdbEncryptionMethod& Lib "CHEETAH2.DLL" Alias "XDBENCRYPTIONMETHOD" (ByVal DBFhandle&) 
     Declare Function xdbEncryptionMethod_Z& Lib "CHEETAH2.DLL" Alias "XDBENCRYPTIONMETHOD_Z" (ByVal DBFhandle&) 
     Declare Function xdbTempFileName$ Lib "CHEETAH2.DLL" Alias "XDBTEMPFILENAME" () 
     Declare Function xdbTempFileName_Z Lib "CHEETAH2.DLL" Alias "XDBTEMPFILENAME_Z" () As Long  
 

' ----------------------------------------------------------------------------------------------------
' EQUATES - General and Error Codes
' ----------------------------------------------------------------------------------------------------
     %XDBTRUE = 1                     
     %XDBFALSE = 0                    
     %MAX_INDEXES           = 100   
     %MAX_FIELDS            = 1000  
     %MAX_CONDITIONS        = 50    
     %MAX_INDEXKEYS         = 6     
     %MAX_CHARFIELD_SIZE    = 256   
     %MAX_NUMFIELD_SIZE     = 20    
     %ENCRYPT_NONE          = 0     
     %ENCRYPT_RC4           = 1     
     %ENCRYPT_KEYEDXOR      = 2     
     %ENCRYPT_SUPERSCRAMBLE = 3     
     %QUERY_AND = 1  
     %QUERY_OR  = 2  
     %EQUAL_TO              = 1   
     %NOT_EQUAL_TO          = 2   
     %LESS_THAN             = 3   
     %GREATER_THAN          = 4   
     %LESS_THAN_EQUAL_TO    = 5   
     %GREATER_THAN_EQUAL_TO = 6   
     %CONTAINS              = 7   
     %BETWEEN               = 8   
     %SUM                   = 9   
     %MINIMUM               = 10  
     %MAXIMUM               = 11  
     %AVERAGE               = 12  
     %WILDCARD              = 13  
     %SORT_ASCEND           = 1   
     %SORT_DESCEND          = 0   
     %XDBREADONLY  = 0  
     %XDBWRITEONLY = 1  
     %XDBREADWRITE = 2  
     %XDBDENYREADWRITE = 1  
     %XDBDENYWRITE     = 2  
     %XDBDENYREAD      = 3  
     %XDBDENYNONE      = 4  
     %XDBUNIQUE_CONTINUE = 0          
     %XDBUNIQUE_ERROR = 1             
     %FILE_ACCESS_ERROR = 4000        
     %INVALID_DATE_FORMAT = 4001      
     %FILE_READ_ONLY = 4002           
     %FILE_WRITE_ONLY = 4003          
     %INVALID_FILENAME = 4004         
     %ENGINE_NOT_INITIALIZED = 5000   
     %FILE_NOT_FOUND = 5001           
     %TOO_MANY_FILES_OPEN = 5002      
     %INVALID_STRUCTURE = 5003        
     %FILE_NOT_OPEN = 5004            
     %RECORD_OUT_OF_RANGE = 5005      
     %FIELD_NOT_FOUND = 5006          
     %INVALID_FILE_HANDLE = 5007      
     %INVALID_FIELD_LENGTH = 5008     
     %DUPLICATE_ALIAS_NAME = 5009     
     %INVALID_ACCESSMODE = 5010       
     %INVALID_SHAREMODE = 5011        
     %RECORD_BUSY = 5012              
     %INCOMPATIBLE_MEMO_FIELDS = 5013 
     %RECORDSIZE_EXCEEDED = 5014      
     %INVALID_ENCRYPTIONKEY = 5015    
     %DATABASE_NOT_OPEN = 7000        
     %TOO_MANY_INDEXES_OPEN = 7002    
     %INVALID_KEY_EXPRESSION = 7003   
     %INDEX_NOT_OPEN = 7004           
     %INDEX_UNIQUE_KEYS_ONLY = 7005   
     %SEEK_NO_INDEX_SET = 7006        
     %INDEX_NOT_FOUND = 7007          
     %QUERY_NOT_GENERATED = 9000         
     %QUERY_INVALID_FIELDNAME = 9001     
     %QUERY_INVALID_COMPARISON = 9002    
     %QUERY_MISSING_DELIMITERS = 9003    
     %QUERY_MISSING_SEARCHSTRING = 9004  
     %QUERY_TOO_MANY_EXPRESSIONS = 9005  
     %QUERY_EXPECTED_NUMERIC_STRING = 9006 
     %QUERY_ERROR_GETRECORD = 9007       
     %QUERY_INVALID_HANDLE = 9008        
     %QUERY_INVALID_JOINPHRASE = 9009    
     %QUERY_NO_WILDCARD_FOUND = 9010     '
     %QUERY_INVALID_PARENTHESIS = 9011   '
     %DLL_EXPIRED = 99999  
 
