#ifndef Node_included
	#include "Node.h"
#endif

#ifndef BigFloat_included

class BigFloat: public Node 
{
	public: 
		MAPM float_;

		static MAPM deg2rad;
		static const BigFloat aBigFloat;

		operator_new;
		BigFloat():         Node(BIGFLOAT), float_(0) {}
		BigFloat(double f): Node(BIGFLOAT), float_(f) {}
		BigFloat(MAPM f): Node(BIGFLOAT), float_(f) {}
		void free();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP   string();
		   int   numberP() {return 1;}
		double getnumber();
		 NodeP    number() {return this;}

		OPERATORS_DECL
		int compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d), _max(double d);
		NodeP Norm(), maxNorm(), 
			item(NodeP index, NodeP result),
			memberP(NodeP subobj, bool notp, bool substr);
//			readbin(FileP file);
		PairP list();

		static void init();
		static MAPM 
			Remainder(MAPM x, MAPM d), 
			      mod(MAPM x, MAPM d);
};

#define BigFloat_included
#endif