#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/object.h>
#include <wx/app.h>
#include <wx/listctrl.h>
#include <stdio.h>

#include "Main.h"
#include "File.h"
#include "Pair.h"
#include "Object.h"
#include "Table.h"
#include "String.h"

#include "Error.h"
#include "Eval.h"
#include "Stack.h"
#include "Workspce.h"

#include "Calls.h"
#include "LogoApp.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

Calls::Calls(wxWindow* parent, wxWindowID id, 
				 const wxPoint& pos, 
				 const wxSize& size, 
				 long style, 
				 const wxValidator& validator, 
				 const wxString& name):
wxListCtrl(parent, id, pos, size, style, validator, name)
{
	inupdate=false;
	InsertColumn(0, "Calls", wxLIST_FORMAT_LEFT, 600);
	theApp->calls=this;
	return;
}

wxString Calls::OnGetItemText(long item, long column) const
{
	return callarr[item];
}

void Calls::update()
{
	if (inupdate)
		return;

	inupdate=true;
	int y=0;
	PairP callslistStart=PairP(lCalls(argStack)),
		callslist=callslistStart;

	if (callslist)
		count=callslist->count();
	else
		count=0;

	callarr.Clear(); callarr.Alloc(count); callarr.Add(wxEmptyString, count);

	while (callslist)
	{
		PairP cf=callslist->first();
		if (cf)
		{
if (y >= count)
{	c_out << "Calls::update error " << count << callslistStart << endL;
	break;
}
			StringP call=StringP(cf->string());
			call=new String(
				call->ptr(),0,call->length(), STRING, String::copy_noformat);
			callarr[y]=call->ptr();
		}
		y++;
		next(callslist);
	}
	SetItemCount(count);
	if (count >= 1)
		RefreshItems(0, count-1);
	inupdate=false;
}
/*
void Calls::update()
{
	DeleteAllItems();
	int y=0;
	PairP callslist=PairP(_Calls(argStack));

	while (callslist)
	{
		PairP cf=callslist->first();
		if (cf)
		{	StringP call=StringP(cf->string());
			call=new String(
				call->ptr(),0,call->length(), STRING, String::copy_noformat);
			InsertItem(y, call->ptr());
		}
		y++;
		next(callslist);
	}
}
*/


NodeP lupdateCalls(PairPP)
{
	if (theApp && theApp->calls) 
		theApp->calls->update();
	return Unbound;
}
