//___________________________________________________________________
//
//                         CheckBox Header
//___________________________________________________________________


extern Function 
	lCheckBox, lCheckBoxDestroy, lCheckBoxOnClick,
	lCheckBoxValue, lCheckBoxSet, lCheckBoxEnable;

class CheckBox: public wxCheckBox
{
	public:
		PairP onClick;
		CheckBoxNodeP checkBoxNode;

		CheckBox(CheckBoxNodeP checkBoxNode_);
		CheckBox(CheckBoxNodeP checkBoxNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label,
			PairP onClick_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "CheckBox");
		~CheckBox();

		void 
			OnClose(wxCloseEvent &event),
			OnClick(wxCommandEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef CheckBox *CheckBoxP;

class CheckBoxNode: public Node
{
	public:
		CheckBoxP checkBox;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;

		static const CheckBoxNode aCheckBoxNode;

		operator_new;
		PairP onClick();
		void setonClick(NodeP function);

		CheckBoxNode();
		CheckBoxNode(
			FrameNodeP parentFrame_,
			GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
