//___________________________________________________________________
//
//                         ChoiceBox Header
//___________________________________________________________________


extern Function 
	lChoiceBox, lChoiceBoxDestroy,
	lChoiceBoxSelection, lChoiceBoxSetSelection,
	lChoiceBoxSetChoices, 
	lChoiceBoxAppend, 
	lChoiceBoxSetItem, lChoiceBoxRemoveItem, 
	lChoiceBoxCount,
	lChoiceBoxSetBackgroundColor, lChoiceBoxSetColor,
	lChoiceBoxSetFontSize, lChoiceBoxSetFontName,
	lChoiceBoxSetFontStyle, lChoiceBoxSetFontWeight,
	lChoiceBoxOnChar, lChoiceBoxOnKeyDown, lChoiceBoxOnKeyUp,
	lChoiceBoxOnSelect,
	lChoiceBoxEnable;

class wxStaticText;
class MyChoiceBox;

class ChoiceBox: public wxControl
{
	public:
		wxStaticText *label;
		MyChoiceBox *choiceBox;
		wxSize bestSize;
		wxArrayString choices;

		PairP onSelect, onChar, onKeyUp, onKeyDown;
		ChoiceBoxNodeP choiceBoxNode;

		ChoiceBox(ChoiceBoxNodeP choiceBoxNode_, int style);
		ChoiceBox(ChoiceBoxNodeP choiceBoxNode_,
			wxWindow* parent, wxWindowID id, 
			const wxArrayString& choices_, 
			PairP onSelect_=PairP(0),
			const wxPoint& pos=wxDefaultPosition, 
			const wxSize& size=wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "ChoiceBox");

		bool create(wxWindow* parent, wxWindowID id, 
			const wxArrayString& choices_, 
			const wxPoint& pos, 
			const wxSize& size, 
			long style, 
			const wxValidator& validator, 
			const wxString& name);

		~ChoiceBox();

		virtual void DoSetSize(int x, int y, int width, int height,
						   int sizeFlags = wxSIZE_AUTO);

		virtual wxSize DoGetBestSize();

		virtual void Set(wxArrayString &choices);

		void 
			OnClose	(wxCloseEvent &event),
			OnSelect	(wxCommandEvent &event),
			OnChar	(wxKeyEvent &event),
			OnKeyDown(wxKeyEvent &event),
			OnKeyUp	(wxKeyEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		virtual bool SetBackgroundColour(const wxColour& colour);
		virtual bool SetForegroundColour(const wxColour& colour);
		virtual bool SetFont(const wxFont& font);

		DECLARE_EVENT_TABLE()
};
typedef ChoiceBox *ChoiceBoxP;

class ChoiceBoxNode: public Node
{
	public:
		ChoiceBoxP choiceBox;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;
		int style;

		static const ChoiceBoxNode aChoiceBoxNode;

		operator_new;
		PairP onSelect(), onChar(), onKeyDown(), onKeyUp();
		void
			setonSelect	(NodeP function),
			setonChar	(NodeP function), 
			setonKeyDown(NodeP function),
			setonKeyUp	(NodeP function);

		ChoiceBoxNode();
		ChoiceBoxNode(FrameNodeP parentFrame_, GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
