//___________________________________________________________________
//
//                           Class Color
//___________________________________________________________________

class wxTextInputStream;
class wxTextOutputStream;
class wxDataInputStream;
class wxDataOutputStream;

class Color
{
	public:
		struct RGBA_struct {unsigned r:8, g:8, b:8, a:8;};
		union
		{	unsigned i;
			struct {unsigned r:8, g:8, b:8, a:8;};
			unsigned rgb:24;
		};
		Color() {}
		Color(unsigned color_) {i=color_;}
		Color(unsigned char r_, unsigned char g_, unsigned char b_) 
		{	r=r_; g=g_; b=b_; a=255;
		}
		Color(unsigned r_, unsigned g_, unsigned b_) 
		{	r=r_; g=g_; b=b_; a=255;
		}
		Color(unsigned r_, unsigned g_, unsigned b_, unsigned a_) 
		{	r=r_; g=g_; b=b_; a=a_;
		}
		Color(double r_, double g_, double b_) 
		{	r=UInt8::clip(255*r_);
			g=UInt8::clip(255*g_);
			b=UInt8::clip(255*b_);
			a=255;
		}
		Color(double r_, double g_, double b_, double a_) 
		{	r=UInt8::clip(255*r_);
			g=UInt8::clip(255*g_);
			b=UInt8::clip(255*b_);
			a=UInt8::clip(255*a_);
		}
		operator int() {return i;}

		friend wxTextInputStream &operator>>(wxTextInputStream &istr, Color &c);
		friend wxTextOutputStream &operator<<(wxTextOutputStream &ostr, Color &c);
		friend wxDataInputStream &operator>>(wxDataInputStream &istr, Color &c);
		friend wxDataOutputStream &operator<<(wxDataOutputStream &ostr, Color &c);
};

typedef Color* ColorP;

class ColorFiFo		// is a First-in-First-out buffer class for Colors.
{
	public:
		bool allocated, _overflow;
		int size, expand_size;
		ColorP base, max, in, out;

		ColorFiFo(int expand_size_) 
		{	expand_size=expand_size_;
			allocated=_overflow=false; 
			size=0; 
			base=max=in=out=0; 
			expand();
		}
		~ColorFiFo();

		ColorFiFo &operator<<(const Color val);
		ColorFiFo &operator>>(Color &val);

		operator bool() {return in!=out;}
		ColorFiFo &operator=(ColorFiFo &b);
		bool overflow() {return _overflow;}
		void reset_in() {in=base;}
		void reset_out() {out=base;}
		void reset() {in=out=base;}
		void expand();
};
