#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Float_included

class Float: public Node 
{
	public: 
		double float_;

		static const int digits;
		static const double max_, pi, deg2rad, 
			NaN, quietNaN, epsilon;
		static const Float aFloat;

		struct x87_ControlWord 
		{	unsigned short
				invalid_operation: 1, denormalized_operand: 1, zerodivide: 1, overflow: 1,	
				underflow: 1, precision: 1, dummy: 1, mask_interrupts: 1,
				precision_control: 2, rounding_control: 2,
				infinity: 1;
		};
		enum x87_Precision {_24bit=0, reserved=1, _53bit=2, _64bit=3};
		enum x87_Rounding {nearest=0, down=1, up=2, chop=3};
	
		static const x87_ControlWord x87_overflow_mask;

		operator_new;
		Float():         Node(FLOAT_), float_(0) {}
		Float(double f): Node(FLOAT_), float_(f) {}

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP   string();
		   int   numberP() {return 1;}
		double getnumber() {return float_;}
		 NodeP    number() {return this;}

		OPERATORS_DECL
		int compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d), _max(double d);
		NodeP Norm(), maxNorm(), 
			item(NodeP index, NodeP result),
			bititem(NodeP index),
			memberP(NodeP subobj, bool notp, bool substr),
			readbin(FileP file);
		PairP list();
		void setPixelXY(NodeP yin, NodeP color);
		void setPixelXYZ(NodeP yin, NodeP zin, NodeP color);
		void setXYZ(NodeP ynode, NodeP znode);

		static void init(), reset_FPU();
		static double 
			rnd(), 
			abs(double x), 
			sqr(double x), 
			 cutError(double x),
			Remainder(double x, double d), 
			      mod(double x, double d);
};

#define Float_included
#endif
