//___________________________________________________________________
//
//                         Gauge Header
//___________________________________________________________________

extern Function 
	lGauge, lGaugeDestroy,
	lGaugeValue, lGaugeSetValue, lGaugeSetRange,
	lGaugeSetColor, lGaugeSetBackgroundColor;

class wxStaticText;
class MyGauge;

class Gauge: public wxControl
{
	public:
		wxStaticText *label;
		MyGauge *gauge;
		wxSize bestSize;
		GaugeNodeP gaugeNode;

		Gauge(GaugeNodeP gaugeNode_, int style);
		Gauge(GaugeNodeP gaugeNode_,
			wxWindow* parent, wxWindowID id, 
			int range, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "Gauge");

		bool create(wxWindow* parent, wxWindowID id, 
			int range, 
			const wxPoint& pos, 
			const wxSize& size, 
			long style, 
			const wxValidator& validator, 
			const wxString& name);

		~Gauge();

		virtual void DoSetSize(int x, int y, int width, int height,
						   int sizeFlags = wxSIZE_AUTO);

		virtual wxSize DoGetBestSize();

		virtual bool SetBackgroundColour(const wxColour& colour);
		virtual bool SetForegroundColour(const wxColour& colour);

		void 
			OnClose(wxCloseEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};
typedef Gauge *GaugeP;

class GaugeNode: public Node
{
	public:
		GaugeP gauge;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;
		int style;

		static const GaugeNode aGaugeNode;

		operator_new;

		GaugeNode();
		GaugeNode(
			FrameNodeP parentFrame_,
			GraphNodeP parentGraph_);

		void free();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
