//___________________________________________________________________
//
//                         IntControl Header
//___________________________________________________________________


extern Function 
	lIntControl, lIntControlDestroy,
	lIntControlValue, lIntControlSetValue, 
	lIntControlSetRange, lIntControlOnChange,
	lIntControlEnable;

class wxStaticText;

class IntControl: public wxSpinCtrlInt
{
	public:
		PairP onChange;
		IntControlNodeP intControlNode;

		IntControl(IntControlNodeP intControlNode_, int style);
		IntControl(IntControlNodeP intControlNode_,
			wxWindow* parent, wxWindowID id, 
			int value , int minValue, int maxValue, 
			PairP onScroll_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxSP_ARROW_KEYS, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = "IntControl");
		~IntControl();

		void 
			OnClose(wxCloseEvent &event),
			OnChange(wxSpinEvent &event);

		wxString wxstring();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef IntControl *IntControlP;

class IntControlNode: public Node
{
	public:
		IntControlP intControl;
		FrameNodeP parentFrame;
		GraphNodeP parentGraph;
		int style;

		static const IntControlNode aIntControlNode;

		operator_new;
		PairP onChange();
		void setonChange(NodeP function);

		IntControlNode();
		IntControlNode(
			FrameNodeP parentFrame_, 
			GraphNodeP parentGraph_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr();
		void check_oldyoungs();
		
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
		void recreate();

		StringP string();
		wxString wxstring();
		StringP _typeof();

		void setParentFrame(FrameNodeP frame);
		void setParentGraph(GraphNodeP graph);
};
