//___________________________________________________________________
//
//                         Class LogoApp
//___________________________________________________________________

extern Function 
	lLogoInstance, lwait, lwaitMS, lwaituS,
	lTimeFine, lTimeMilli, lTimeu, lTimeuRes, lTimerFreq, lTime,
	lMIPS, 
	lSound, lSounds, lSoundsStop, lSoundsFinished, 
	lTone , lTones , lTonesStop , lTonesFinished ,
	lplayWave, lplayWaveFast;

class Graph;
class Vars;
class Calls;
class MainFrame;
class wxHelpController;
class wxConfig;
class wxNotebook;
class EdFrame;
class MemoryWindow;
class MemoryFrame;

enum AppAction
{	NOP,
	EXIT_LOGO,
	EXIT_DELAYED,
	ON_RUN,
	ON_STEP,
	PAUSE,
	CONTROL_PAUSE,
	LOAD_NODES,
	SAVE_NODES,
};

class LogoApp : public wxApp
{
	public:
		AppAction action;
		bool saved, memoryShown, doubleBuffer;
		int memposx, memposy, memsizex, memsizey;
		wxPoint max;

		charP heapReserve;
		MainFrame *mainFrame;
		Vars *vars;
		Calls *calls;
		EdFrame *edFrame;
		wxHelpController *help;
		MemoryWindow *memoryWindow;
		MemoryFrame *memoryFrame;

		wxConfig *config;
		bool backup;
		wxString runDirectory, helpFileName, aUCBLogo, 
			consoleFileName, pictureFileName, nodesFileName;

		bool OnInit();
		int OnExit();
		int MainLoop();
		void doAction();
		void memoryShow(), memoryHide();

		void waituS(int n);
		void Sound(double frequency, double duration);
		void Tone(double pitch, double duration);

		int osVersion, osMajor, osMinor;
};

extern LogoApp *theApp;

#ifndef WIN32
	#define _LARGE_INTEGER long long
#endif

union TimeUnion {_LARGE_INTEGER i; __int64 u;};

