//___________________________________________________________________
//
//                          Main Header
//___________________________________________________________________

#ifndef WIN32
	#define __cdecl
	#define __stdcall
	#define __single_inheritance
	#define __int64 long long
	#define DWORD unsigned int
	#define WINAPI
	#define LPVOID void *
	#define CALLBACK
	#define byte unsigned char
#endif

#ifdef _DEBUG
//	#define DEBUG_NEW new(THIS_FILE, __LINE__)
#endif

#define NIL PairP(0)

typedef   char*   charP;	typedef charP* charPP;
typedef  short*  shortP;
typedef    int*    intP;
typedef double* doubleP;
typedef FILE* FILEP;

#ifdef PTR_DEBUG
	#include "PtrDebug.h"
#else
	class GC_;
		class Node;			typedef Node* NodeP;		typedef NodeP* NodePP;
			class Int;			typedef Int* IntP;
			class Int16;		typedef Int16* Int16P;
			class Int8;			typedef Int8* Int8P;
			class UInt8;		typedef UInt8* UInt8P;
			class Float;		typedef Float* FloatP;
			class BigFloat;	typedef BigFloat* BigFloatP;
			class Complexd;	typedef Complexd* ComplexdP;
			class Primitive;	typedef Primitive* PrimitiveP;
			class Array;		typedef Array* ArrayP;
			class IntArray;	typedef IntArray* IntArrayP;
			class Int16Array;	typedef Int16Array* Int16ArrayP;
			class FloatArray;	typedef FloatArray* FloatArrayP;
			class String;		typedef String* StringP;
			class Bitmap;		typedef Bitmap* BitmapP;
			class Texture;		typedef Texture* TextureP;
			class TurtleNode;	typedef TurtleNode* TurtleNodeP;

			class Pair;			typedef Pair* PairP;		typedef PairP* PairPP;
				class Line;			typedef Line* LineP;
					class Runparsed;	typedef Runparsed* RunparsedP;
					class Tree;			typedef Tree* TreeP;
				class List;			typedef List* ListP;
				class Quote;		typedef Quote* QuoteP;
				class Colon;		typedef Colon* ColonP;
				class WindowPair;	typedef WindowPair* WindowPairP;
			class Object;		typedef Object* ObjectP;		typedef ObjectP* ObjectPP;
			class Procedure;	typedef Procedure* ProcedureP;
			class File;			typedef File* FileP;
			class Table;		typedef Table* TableP;
			class Struct;		typedef Struct* StructP;
			class GraphicNode;typedef GraphicNode* GraphicNodeP;
			class DynamicLibrary;typedef DynamicLibrary* DynamicLibraryP;
			class SliderNode;			typedef SliderNode* SliderNodeP;
			class GaugeNode;			typedef GaugeNode* GaugeNodeP;
			class IntControlNode;	typedef IntControlNode* IntControlNodeP;
			class FloatControlNode;	typedef FloatControlNode* FloatControlNodeP;
			class FrameNode;			typedef FrameNode* FrameNodeP;
			class GraphNode;			typedef GraphNode* GraphNodeP;
			class ButtonNode;			typedef ButtonNode* ButtonNodeP;
			class ToggleButtonNode;	typedef ToggleButtonNode* ToggleButtonNodeP;
			class CheckBoxNode;		typedef CheckBoxNode* CheckBoxNodeP;
			class RadioButtonNode;	typedef RadioButtonNode* RadioButtonNodeP;
			class StaticTextNode;	typedef StaticTextNode* StaticTextNodeP;
			class TextControlNode;	typedef TextControlNode* TextControlNodeP;
			class ListBoxNode;		typedef ListBoxNode* ListBoxNodeP;
			class ChoiceBoxNode;		typedef ChoiceBoxNode* ChoiceBoxNodeP;
			class ComboBoxNode;		typedef ComboBoxNode* ComboBoxNodeP;
			class ListControlNode;	typedef ListControlNode* ListControlNodeP;
			class BoxSizerNode;		typedef BoxSizerNode* BoxSizerNodeP;
#endif

typedef NodeP (Function)(PairPP);
typedef Function *FunctionP;

enum ControlType {RUN=0, BREAK, CONTINUE, STOP, OUTPUT, THROWING, MACRO_RETURN};

extern ControlType stoppingFlag;

#define running    (stoppingFlag==RUN)
#define stopping   (stoppingFlag==STOP)
#define outputting (stoppingFlag==OUTPUT)
#define throwing   (stoppingFlag==THROWING)

extern bool inpause, instep, stepArmed, updateVarsOnStep;

#define exist(nr)  (argStack.greaterEqual(arg+(nr)))
#define noarg      (arg==argStack)

#define next(p)    (p) = (p)->tail()

class Var
{	public:
		ObjectP object; NodeP val;
		void mark(), markPtr();
};
typedef Var* VarP;

class ErrorStruct
{	public:
		ObjectP fun, ufun;
		LineP this_line;
		void mark(), markPtr();
};
typedef ErrorStruct *ErrorStructP;

class Environment
{	public:
		bool fontsMalloced;
		wxString logolib, helpfiles, editor, editorname,
			tempdir, comspec, fonts;
		Environment();
		~Environment();
};
extern Environment environment;

class Color;

extern bool checkThrowing();
extern void push(PairP &stack, NodeP obj);

extern void mySwapBuffers();

extern int _cdecl _main(int argc, charP argv[]);
extern charP aUCBLogo;
