#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Primitive_included

struct PrimType
{	charP name;
	char min, std, max;
	Priority priority;
	FunctionP function;
};

class Primitive: public Node		// is a function having a Priority and argument numbers
{
	FunctionP _function;

	public:
		Priority priority;
		char min, std, max;

		static const Primitive aPrimitive;
		static const char ok_if_no_arg;
		static PrimType primitives[];

		operator_new;
		Primitive(): _function(0), priority(priority_STOP) {}
		Primitive(NodeType type): Node(type), _function(0), priority(priority_STOP) {}
		Primitive(PrimType &prim);

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		FunctionP function() {return _function;}

		StringP _typeof();
		PairP gather_args(PairPP args, bool inparen, ObjectPP ifnode);
		NodeP call(PairPP asp) {return (*_function)(asp);}

		static void init(bool caseIgnored);
};

#define Primitive_included
#endif