//___________________________________________________________________
//
//         PtrDebug implementation  for strict type checking
//___________________________________________________________________

IntP::NPtr<Int>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==INT_)) p = p_.p; 
	else
		exit(0xBAD0030);
}
Int16P::NPtr<Int16>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==INT16)) p = p_.p; 
	else
		exit(0xBAD0030);
}
Int8P::NPtr<Int8>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==INT8)) p = p_.p; 
	else
		exit(0xBAD0030);
}
UInt8P::NPtr<UInt8>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==UINT8)) p = p_.p; 
	else
		exit(0xBAD0030);
}
FloatP::NPtr<Float>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==FLOAT_)) p = p_.p; 
	else
		exit(0xBAD0031);
}
ComplexdP::NPtr<Complexd>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==COMPLEX)) p = p_.p; 
	else
		exit(0xBAD0032);
}
PrimitiveP::NPtr<Primitive>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->is.primitive)) p = p_.p; 
	else
		exit(0xBAD0033);
}
ArrayP::NPtr<Array>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==ARRAY)) p = p_.p; 
	else
		exit(0xBAD0034);
}
IntArrayP::NPtr<IntArray>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==INTARRAY)) p = p_.p; 
	else
		exit(0xBAD0034);
}
Int16ArrayP::NPtr<Int16Array>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==INT16ARRAY)) p = p_.p; 
	else
		exit(0xBAD0034);
}
StringP::NPtr<String>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) 
	&& (!p_.p || p_.p->is.string || _Null_Word==p_)) 
		p = p_.p; 
	else
		exit(0xBAD0035);
}
BitmapP::NPtr<Bitmap>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==BITMAP_)) p = p_.p; 
	else
		exit(0xBAD0036);
}
TurtleNodeP::NPtr<TurtleNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==TURTLE_)) p = p_.p; 
	else
		exit(0xBAD0037);
}
GraphicNodeP::NPtr<GraphicNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==GRAPHIC)) p = p_.p; 
	else
		exit(0xBAD0037);
}
PairP::NPtr<Pair>(const NodeP p_)
{	if (is_nil_or_ok(p_.p)) p = p_.p; 
	else
		exit(0xBAD0038);
}
ObjectP::NPtr<Object>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==OBJECT)) p = p_.p; 
	else
		exit(0xBAD0039);
}
ProcedureP::NPtr<Procedure>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) 
	&& (!p_.p || Unbound==p_ || p_.p->type==PROC_)) 
		p = p_.p; 
	else
		exit(0xBAD003A);
}
FileP::NPtr<File>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==FILE_)) p = p_.p; 
	else
		exit(0xBAD003B);
}
ToDoNodeP::NPtr<ToDoNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==TODO)) p = p_.p; 
	else
		exit(0xBAD003C);
}
TableP::NPtr<Table>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==TABLE)) p = p_.p; 
	else
		exit(0xBAD003D);
}
StructP::NPtr<Struct>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==STRUCT)) p = p_.p; 
	else
		exit(0xBAD003E);
}
DynamicLibraryP::NPtr<DynamicLibrary>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==DYNAMIC_LIB)) p = p_.p; 
	else
		exit(0xBAD003F);
}
BoxSizerNodeP::NPtr<BoxSizerNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==BOXSIZER)) p = p_.p; 
	else
		exit(0xBAD0040);
}
GraphNodeP::NPtr<GraphNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==GRAPH)) p = p_.p; 
	else
		exit(0xBAD0041);
}
FrameNodeP::NPtr<FrameNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==FRAME)) p = p_.p; 
	else
		exit(0xBAD0042);
}
ListControlNodeP::NPtr<ListControlNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==LISTCONTROL)) p = p_.p; 
	else
		exit(0xBAD0043);
}
ComboBoxNodeP::NPtr<ComboBoxNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==COMBOBOX)) p = p_.p; 
	else
		exit(0xBAD0044);
}
ChoiceBoxNodeP::NPtr<ChoiceBoxNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==CHOICEBOX)) p = p_.p; 
	else
		exit(0xBAD0045);
}
ListBoxNodeP::NPtr<ListBoxNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==LISTBOX)) p = p_.p; 
	else
		exit(0xBAD0046);
}
TextControlNodeP::NPtr<TextControlNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==TEXTCONTROL)) p = p_.p; 
	else
		exit(0xBAD0047);
}
StaticTextNodeP::NPtr<StaticTextNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==STATICTEXT)) p = p_.p; 
	else
		exit(0xBAD0048);
}
RadioButtonNodeP::NPtr<RadioButtonNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==RADIOBUTTON)) p = p_.p; 
	else
		exit(0xBAD0049);
}
CheckBoxNodeP::NPtr<CheckBoxNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==CHECKBOX)) p = p_.p; 
	else
		exit(0xBAD004A);
}
ToggleButtonNodeP::NPtr<ToggleButtonNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==TOGGLEBUTTON)) p = p_.p; 
	else
		exit(0xBAD004B);
}
ButtonNodeP::NPtr<ButtonNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==BUTTON)) p = p_.p; 
	else
		exit(0xBAD004C);
}
FloatControlNodeP::NPtr<FloatControlNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==FLOATCONTROL)) p = p_.p; 
	else
		exit(0xBAD004D);
}
IntControlNodeP::NPtr<IntControlNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==INTCONTROL)) p = p_.p; 
	else
		exit(0xBAD004E);
}
GaugeNodeP::NPtr<GaugeNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==GAUGE)) p = p_.p; 
	else
		exit(0xBAD004F);
}
SliderNodeP::NPtr<SliderNode>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==SLIDER)) p = p_.p; 
	else
		exit(0xBAD0050);
}
FloatArrayP::NPtr<FloatArray>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==FLOATARRAY)) p = p_.p; 
	else
		exit(0xBAD004F);
}
TextureP::NPtr<Texture>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==TEXTURE)) p = p_.p; 
	else
		exit(0xBAD004F);
}
BigFloatP::NPtr<BigFloat>(const NodeP p_)
{	if (is_nil_or_ok(p_.p) && (!p_.p || p_.p->type==BIGFLOAT)) p = p_.p; 
	else
		exit(0xBAD004F);
}

Object &ObjectP::operator[](int i)
{	Object &nd = *(Object*)&p[i];
	if (is_nil_or_ok(&nd)) return nd;
	exit(0xBAD00A0);	return Object();
}

NodeP &NodeP::operator++(int) 
{	NodeP np=p;
	p++;
	if (!p || is_nil_or_ok(p)) return np;
	exit(0xBAD00E0);	return NodeP(0);
}
