//___________________________________________________________________
//
//                         Class PtrToInt
//
//                           Definitions
//___________________________________________________________________

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <stdio.h>
#include <malloc.h>

#include <wx/datstrm.h>

#include "Main.h"
#include "Node.h"
#include "PtrToInt.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)

	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

PtrToInt::PtrToInt(int size_):
	size(0), nr(0), start(0), last(0)
{
	data = (PtrIntPairP*)(GC_::calloc(size_, sizeof(PtrIntPairP)));
	if (data)
		size=size_;
}

PtrToInt::~PtrToInt()
{
	for (int i=0; i < size; i++)
	{	if (data[i])
			delete data[i];
	}
	if (data)
		free(data);
}

int PtrToInt::hash(void *p)
{
	unsigned int index = (unsigned int)p;
	if (size)
		index %= size;
	else
		index=0;
	return index;
}

int PtrToInt::find(void *p)
{
	PtrIntPairP obj;
	for (obj=data[hash(p)];  obj;  obj=obj->tail)
		if (obj->p==p)
			return obj->i;
	return 0;
}

void PtrToInt::insert(void *p)
{
	nr++;
	PtrIntPairP &obj=data[hash(p)];
	obj = new PtrIntPair(p, nr, obj);
}

void PtrToInt::insertNode(NodeP p)
{
/*	switch (p->type)
	{
	case UNBOUND:
	case STRING:
	case BACKSLASHED:
	case VBAR_STRING:
	case INT_:
	case FLOAT_:
	case COMPLEX:
	case INT16:
	case INT8:
	case UINT8:
	case QUOTE:
	case COLON:
	case OBJECT:
	case PAIR:
	case LINE:
	case RUNPARSED:
	case TREE:
	case TODO:
	case FILE_:
	case PROC_:
	case ARRAY:
	case BITMAP_:
	case TEXTURE:
	case TURTLE_:
	case TABLE:
	case STRUCT:
	case GRAPHIC:
	case DYNAMIC_LIB:
	case INTARRAY:
	case INT16ARRAY:
	case FLOATARRAY:
	case PRIM:
	case MACRO:
	case TAILFORM:
	case INFIX:
	{
*/		nr++;
		PtrIntPairP &obj=data[hash(p)];
		obj = new PtrIntPair(p, nr, obj);
		if (!start)
		{	start=obj;
			last=obj;
		}
		else
		{	last->nxt=obj;
			last=obj;
		}
/*		break;
	}
	default: 
		nr=nr;
	}
*/
}

wxDataOutputStream &PtrToInt::writeNodes(wxDataOutputStream &ostr)
{
	PtrIntPairP obj=start;
	while (obj)
	{	((Node*)obj->p)->write(ostr);
		obj=obj->nxt;
	}
	return ostr;
}
