//___________________________________________________________________
//
//                           Class Stack
//___________________________________________________________________

//#define _DEBUG
class IntStack
{
	int item, maxitem;
	public:
		int size;
		intP base, index, max;

		static bool noisy;

		IntStack();
		~IntStack();

		bool grow();
		bool shrink();
#ifdef _DEBUG
		void push(int val), pop(int &val);
		IntStack 
			&operator<<(const int val),
			&operator>>(int &val),
			&operator>>(bool &val),
			&operator>>(TailCall &val),
			&operator>>(ValStatus &val);

		void 
			push(int  i1, int  i2),
			push(int  i1, int  i2, int  i3),
			 pop(int &i1, int &i2),
			 pop(int &i1, int &i2, int &i3),
			 pop(ValStatus &i1, TailCall &i2),
			 pop(ValStatus &i1, TailCall &i2, int &i3);
#else
	IntStack &operator<<(const int val) 
	{
/*		try
		{	*++index = val;
		}
		catch (unsigned)
		{	if (grow())
				*index=val;
			else
				error(STACK_OVERFLOW);
		}
*/		if (index+1 > max)
			if (!grow())
				return *this;
		*++index=val;
		return *this;
	}
	IntStack &operator>>(      int &val) {val = *index--; return *this;}
	IntStack &operator>>(     bool &val) {(int&)val =    (*index--); return *this;}
	IntStack &operator>>( TailCall &val) {val =  TailCall(*index--); return *this;}
	IntStack &operator>>(ValStatus &val) {val = ValStatus(*index--); return *this;}

	void push(int i1, int i2)
	{	if (index+2 > max)
			if (!grow())
				return;
		index[1]=i1;
		index[2]=i2;
		index+=2;
	}
	void push(int i1, int i2, int i3)
	{	
/*		try
		{	i[3]=i3;
		}
		catch (unsigned)
		{	if (grow())
			{	i=index;
				i[3]=i3;
			}else
				error(STACK_OVERFLOW);
		}
		i[2]=i2;
		i[1]=i1;
		index=i+3;
*/		if (index+3 > max)
			if (!grow())
				return;
		index[1]=i1;
		index[2]=i2;
		index[3]=i3;
		index+=3;
	}
	void pop(int &i1, int &i2)
	{	register intP i=index;
		i2=*i--; i1=*i--;
		index=i;
	}
	void pop(int &i1, int &i2, int &i3)
	{	register intP i=index;
		i3=*i--; i2=*i--; i1=*i--;
		index=i;
	}
	void pop(ValStatus &i1, TailCall &i2) 
	{	register intP i=index;
		i2=TailCall(*i--); i1=ValStatus(*i--);
		index=i;
	}
	void pop(ValStatus &i1, TailCall &i2, int &i3)
	{	register intP i=index;
		i3=*i--; i2=TailCall(*i--); i1=ValStatus(*i--);
		index=i;
	}
#endif
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};

class FloatStack
{
	int item, maxitem;
	int size;
	doubleP base, index, max;
	public:
		FloatStack();
		~FloatStack();

		bool grow();
		bool shrink();
#ifdef _DEBUG
		void push(double val), pop(double &val);
		FloatStack 
			&operator<<(const double val),
			&operator>>(double &val);

		void 
			push(double d1, double d2, double d3),
			 pop(double &d1, double &d2, double &d3);
#else
	FloatStack &operator<<(const double val) 
	{	if (index+2 > max)
			if (!grow())
				return *this;
		*++index=val;
		return *this;
	}
	FloatStack &operator>>(      double &val) {val = *index--; return *this;}

	void push(double d1, double d2, double d3)
	{	if (index+4 > max)
			if (!grow())
				return;
		index[1]=d1;
		index[2]=d2;
		index[3]=d3;
		index+=3;
	}
	void pop(double &d1, double &d2, double &d3)
	{	register doubleP i=index;
		d3=*i--; d2=*i--; d1=*i--;
		index=i;
	}
#endif
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};

class NodePStack
{
	public:
		int item, maxitem;
		int size;
		NodeP *base, *index, *max;

		NodePStack();
		~NodePStack();

		bool grow();
		bool shrink();

		bool operator!=(const PairP *b) {return index != (NodeP*)b;}
		bool operator>=(const PairP *b) {return index >= (NodeP*)b;}
		bool greaterEqual(const PairP *b) {return index >= (NodeP*)b;}
		operator PairPP() {return PairPP(index);}
		operator int() {return index-base;}
		PairPP operator-(const int &i) {return PairPP(index-i);}
#ifdef _DEBUG
		void push(NodeP val), pop(NodeP &val), pop(),
			push_list(PairP head), 
			push(ArrayP a), 
			pop_till(PairPP sp),
			clean();

		NodePStack 
			&operator<<(const NodeP  val),
			&operator>>(      NodeP &val),
			&operator>>(      PairP &val),
			&operator>>(      LineP &val),
			&operator>>(    ObjectP &val),
			&operator>>( ProcedureP &val);
		void 
			push(
				const NodeP n1, const NodeP n2, const NodeP n3, const NodeP n4, 
				const NodeP n5, const NodeP n6, const NodeP n7),
			push(
				const NodeP n1, const NodeP n2, const NodeP n3, const NodeP n4, 
				const NodeP n5, const NodeP n6, const NodeP n7, const NodeP n8),
			pop(		NodeP &n1,   NodeP &n2, 
					 NodeP &n3, ObjectP &n4, LineP &n5,  ObjectP &n6, LineP &n7),
			pop(		PairP &n1, NodeP &n2, 
					 NodeP &n3, ObjectP &n4, LineP &n5,  ObjectP &n6, LineP &n7);
#else
	void pop() {index--;}

	NodePStack &operator<<(const NodeP  val) 
	{	if (index+1 > max)
			if (!grow())
				return *this;
		*++index=val;
		return *this;
	}
	NodePStack &operator>>(      NodeP &val) {    val =            *index-- ; return *this;}
	NodePStack &operator>>(      PairP &val) {    val =      PairP(*index--); return *this;}
	NodePStack &operator>>(      LineP &val) {    val =      LineP(*index--); return *this;}
	NodePStack &operator>>(    ObjectP &val) {    val =    ObjectP(*index--); return *this;}
	NodePStack &operator>>( ProcedureP &val) {    val = ProcedureP(*index--); return *this;}

	void push(
		const NodeP n1, const NodeP n2, const NodeP n3, const NodeP n4, 
		const NodeP n5, const NodeP n6, const NodeP n7) 
	{	if (index+7 > max)
			if (!grow())
				return;
		index[1]=n1; index[2]=n2; index[3]=n3; index[4]=n4; 
		index[5]=n5; index[6]=n6; index[7]=n7;
		index+=7;
	}
	void push(
		const NodeP n1, const NodeP n2, const NodeP n3, const NodeP n4, 
		const NodeP n5, const NodeP n6, const NodeP n7, const NodeP n8) 
	{	if (index+8 > max)
			if (!grow())
				return;
		index[1]=n1; index[2]=n2; index[3]=n3; index[4]=n4; 
		index[5]=n5; index[6]=n6; index[7]=n7; index[8]=n8;
		index+=8;
	}
	void pop(
		NodeP &n1, NodeP &n2, 
		NodeP &n3, ObjectP &n4, LineP &n5, 
		ObjectP &n6, LineP &n7)
	{
		register NodeP *i=index;
		n7 =      LineP(*i); 
		n6 =    ObjectP(i[-1]); 
		n5 =      LineP(i[-2]); 
		n4 =    ObjectP(i[-3]); 
		n3 =            i[-4] ; 
		n2 =            i[-5] ; 
		n1 =            i[-6] ; 
		index=i-7;
	}
	void pop(
		PairP &n1, NodeP &n2, 
		NodeP &n3, ObjectP &n4, LineP &n5, 
		ObjectP &n6, LineP &n7)
	{
		register NodeP *i=index;
		n7 =      LineP(*i); 
		n6 =    ObjectP(i[-1]); 

		n5 =      LineP(i[-2]); 
		n4 =    ObjectP(i[-3]); 
		n3 =            i[-4] ; 
		n2 =            i[-5] ; 
		n1 =      PairP(i[-6]); 
		index=i-7;
	}
	void push_list(PairP head) 
	{	while (head) 
		{	NodeP val=NodeP(head->first());
			if (index+1 > max)
				if (!grow())
					return;
			*++index=val;
			next(head);
		}
	}
	void push(ArrayP a);
	void pop_till(PairPP sp) {index=NodePP(sp);}
	void clean() {pop_till(PairPP(base));}
#endif
		void pop_till(int i) 
		{	pop_till((PairPP)&base[i]);
		}
		void mark(), markPtr();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();

		PairP to_list(PairPP sp), to_list_reversed(PairPP sp);
		PairP to_list(int i), to_list_reversed(int i);
};

class PairPPStack
{
	public:
		int item, maxitem;
		int size;
		PairPP *base, *index, *max;

		PairPPStack();
		~PairPPStack();

		bool grow();
		bool shrink();
#ifdef _DEBUG
		void push(PairPP val), pop(PairPP &val);
		PairPPStack 
			&operator<<(const PairPP val),
			&operator>>(PairPP &val);
#else
	PairPPStack &operator<<(const PairPP val) 
	{	if (index+1 > max)
			if (!grow())
				return *this;
		*++index=val;
		return *this;
	}
	PairPPStack &operator>>(PairPP &val) {val = *index--; return *this;}
#endif
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
};

class VarStack
{
	public:
		int item, maxitem;
		int size;
		Var *base, *index, *max;

		VarStack();
		~VarStack();

		bool grow();
		bool shrink();

		bool operator!=(const VarP b) {return index != b;}
		operator VarP() {return index;}
		operator int() {return index-base;}
#ifdef _DEBUG
		void push(ObjectP object_), pop();
		void pop_till(VarP oldSP);	// pop saved vars till old stack pointer
		VarStack &operator<<(const ObjectP object);
#else
	void VarStack::pop() {index->object->setvar( index->val );  index--;}
	void VarStack::pop_till(VarP oldSP) {while (index > oldSP) pop();}

	VarStack &VarStack::operator<<(ObjectP object) 
	{	if (index+2 > max)
			if (!grow())
				return *this;
		++index;
		index->object=object;
		index->val=object->var();
		return *this;
	}
#endif
		void pop_till(int i) 
		{	pop_till(&base[i]);
		}
		void mark(), markPtr();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
};

class VarPStack
{
	public:
		int item, maxitem;
		int size;
		VarP *base, *index, *max;

		VarPStack();
		~VarPStack();

		bool grow();
		bool shrink();
#ifdef _DEBUG
		void push(VarP val), pop(VarP &val);
		VarPStack 
			&operator<<(const VarP val),
			&operator>>(VarP &val);
#else
	VarPStack &operator<<(const VarP val) 
	{	if (index+1 > max)
			if (!grow())
				return *this;
		*++index=val;
		return *this;
	}
	VarPStack &operator>>(VarP &val) {val = *index--; return *this;}
#endif
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
};

class ToDoStack
{
	int item, maxitem;
	int size;
	ToDo *base, *index, *max;
	public:
		ToDoStack();
		~ToDoStack();

		bool grow();
		bool shrink();
#ifdef _DEBUG		
		void push(ToDo val), pop(ToDo &val);
		ToDoStack 
			&operator<<(const ToDo val),
			&operator>>(ToDo &val);
#else
	ToDoStack &operator<<(const ToDo val) 
	{	if (index+2 > max)
			if (!grow())
				return *this;
		*++index=val;
		return *this;
	}
	ToDoStack &operator>>(ToDo &val) {val = *index--; return *this;}
#endif
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};

class ErrorStack
{
	int item, maxitem;
	int size;
	ErrorStruct *base, *index, *max;
	public:
		ErrorStack();
		~ErrorStack();

		bool grow();
		bool shrink();
		ErrorStructP top() {return index;}
#ifdef _DEBUG
		void push(ObjectP fun_, ObjectP ufun_, LineP this_line_), 
			pop();
#else
	void push(ObjectP fun_, ObjectP ufun_, LineP this_line_) 
	{	if (index+2 > max)
			if (!grow())
				return;
		++index;
		index->fun = fun_;
		index->ufun = ufun_;	
		index->this_line = this_line_;
	}
	void pop() {index--;}
#endif
		void mark(), markPtr();

		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs();
};
//#undef _DEBUG

extern NodePStack argStack;
