#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Table_included

class Table: public Node
{
	bool allocated;
	int size;
	ObjectP *base;

	public:
		static const Table aTable;
		operator_new;

		Table(): Node(TABLE), allocated(false), size(0), base(0) {}
		Table(int size_);
		virtual ~Table();
		void free();

		void inc_gc();
		int youngs(), youngsPtr();
		void check_oldyoungs();

		void setPtrs();
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string();

		void mark();
		void mark_all_but_objects();
		void clean();

		int count();
		int _sizeof();
		StringP _typeof();
		NodeP item(NodeP index, NodeP result);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp, bool substr);
		void removeitem(NodeP index);
		PairP list();

		int hash(StringP str);
		ObjectP operator[](StringP str);
		ObjectP find(StringP str);
		ProcedureP findProc(StringP filename, int linenr);
		ObjectP insert(StringP nd);

		PairP objectlist();
		void self_resize(int newsize);

		PairP contents(ContentsType contents_type, ObjectType want);
		PairP contents(ObjectType obj_type);
		PairP contentsNameVar();

		NodeP erase_all(bool procs, bool vals, bool plists);
};
extern TableP root;

	#define Table_included
#endif
